from Plugins.Plugin import PluginDescriptor

from Screens.Screen import Screen
from Screens.InputBox import InputBox
from Screens.MessageBox import MessageBox
from Components.ServicePosition import ServicePositionGauge
from Components.ActionMap import HelpableActionMap
from Components.MenuList import MenuList
from Components.MultiContent import MultiContentEntryText
from Components.ServiceEventTracker import ServiceEventTracker
from Components.ActionMap import ActionMap
from Components.Input import Input
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarCueSheetSupport
from Components.GUIComponent import GUIComponent
from enigma import eListboxPythonMultiContent, eListbox, gFont, iPlayableService, RT_HALIGN_RIGHT, eServiceCenter, eServiceReference
from Screens.FixedMenu import FixedMenu
import os


def main(session, service, **kwargs):
	session.open(RenameMovie, service)

def Plugins(**kwargs):
 	return PluginDescriptor(name="Rename Movie", description=_("rename ..."), where = PluginDescriptor.WHERE_MOVIELIST, fnc=main)


class RenameMovie(Screen):
    skin = """
        <screen position="100,100" size="500,200" title="Rename Movie Menu" >
            <widget name="menu" position="10,10" size="490,190" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, service, args = 0):
        self.skin = RenameMovie.skin
        self.session = session
        Screen.__init__(self, session)
	session.nav.playService(service)
	service = session.nav.getCurrentService()
	self.service = service
        self.menu = args
        list = []
        list.append((_("rename movie title"), "renametitle"))
        list.append((_("rename movie files"), "renamefiles"))
        list.append((_("backup all .meta files"), "backupmeta"))
        list.append((_("restore all .meta files"), "restoremeta"))
        list.append((_("about"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if  os.path.exists("/media/hdd/movie/metabackup") is False:
           os.system("mkdir /media/hdd/movie/metabackup")
        if returnValue is not None:
           if returnValue is "renametitle":
              RenameTitle(self.session)
           elif returnValue is "renamefiles":
              RenameFiles(self.session)
           elif returnValue is "backupmeta":
              os.system("cp /media/hdd/movie/*.ts.meta /media/hdd/movie/metabackup")
              self.session.open(MessageBox,_("%s done !" % returnValue ), MessageBox.TYPE_INFO)
           elif returnValue is "restoremeta":
              os.system("cp /media/hdd/movie/metabackup/*.ts.meta /media/hdd/movie")
              self.session.open(MessageBox,_("%s done !" % returnValue ), MessageBox.TYPE_INFO)
           elif returnValue is "about":
              self.session.open(MessageBox,_("Rename Movie Enigma2 Plugin by gutemine"), MessageBox.TYPE_INFO)
        

class RenameTitle(Screen):
    def __init__(self, session):

        self.session = session
	self.service = session.nav.getCurrentlyPlayingServiceReference()
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(self.service)
	self.oldname = info and info.getName(self.service) or _("this recording")
        self.session.openWithCallback(self.askForNewName,InputBox, title=_("Enter new name for movie"), text="%s" % (self.oldname), maxSize=False, type=Input.TEXT)

    def askForNewName(self,newname):
        if newname is None:
            self.skipRenameMovie("no new name for movie")
        else:
            self.newname = newname.lstrip().rstrip()
            self.session.openWithCallback(self.RenameMovieNow,MessageBox,_("are you sure to rename %s to %s" % (self.oldname,self.newname)), MessageBox.TYPE_YESNO)

    def RenameMovieNow(self,answer):
        if answer is None:
            self.skipRenameMovie("answer is None")
        if answer is False:
            self.skipRenameMovie("you were not confirming")
        else:
            oldtitle=self.oldname.rstrip()
            metafound = False
            for filename in os.listdir("/media/hdd/movie"): 
               if filename.endswith(".ts.meta") is True:
                  metafile = open("/media/hdd/movie/%s" % filename, "r")
                  line = metafile.readline()
                  # second line is title
                  line = metafile.readline()
                  title=line.rstrip()
                  if title == oldtitle: 
                     metafile.close()
                     metafound = True
                     metafile = open("/media/hdd/movie/%s" % filename, "r")
                     text=metafile.read()
                     metafile.close()
                     metafile = open("/media/hdd/movie/%s" % filename, "w")
                     metafile.write(text.replace(self.oldname,self.newname))
                  metafile.close()
            if metafound is True:
               self.session.open(MessageBox,_("rename movie done, check by pressing Video button again !"), MessageBox.TYPE_INFO)
            else:
               self.session.open(MessageBox,_(".meta file not found, sorry"), MessageBox.TYPE_INFO)
            
    def skipRenameMovie(self,reason):
        self.session.open(MessageBox,_("renaming movie was cancelled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        

class RenameFiles(Screen):
    def __init__(self, session):

        self.session = session
	self.service = session.nav.getCurrentlyPlayingServiceReference()
	serviceHandler = eServiceCenter.getInstance()
	info = serviceHandler.info(self.service)
	self.oldname = info and info.getName(self.service) or _("this recording")
        self.session.openWithCallback(self.askForNewFile,InputBox, title=_("Enter new filename for movie"), text="%s" % (self.oldname), maxSize=False, type=Input.TEXT)

    def askForNewFile(self,newname):
        if newname is None:
            self.skipRenameFile("no new name for movie")
        else:
            self.newname = newname.lstrip().rstrip()
            self.session.openWithCallback(self.RenameFilesNow,MessageBox,_("are you sure to rename %s to %s" % (self.oldname,self.newname)), MessageBox.TYPE_YESNO)

    def RenameFilesNow(self,answer):
        if answer is None:
            self.skipRenameFile("answer is None")
        if answer is False:
            self.skipRenameFile("you were not confirming")
        else:
            oldtitle=self.oldname.rstrip()
            newtitle=self.newname.rstrip()
            metafound = False
            moviename =  [ ]
            for filename in os.listdir("/media/hdd/movie"): 
               if filename.endswith(".ts.meta") is True:
                  metafile = open("/media/hdd/movie/%s" % filename, "r")
                  line = metafile.readline()
                  # second line is title
                  line = metafile.readline()
                  title=line.rstrip()
                  if title == oldtitle: 
                     metafile.close()
                     metafound = True
                     metafile = open("/media/hdd/movie/%s" % filename, "r")
                     text=metafile.read()
                     metafile.close()
                     metafile = open("/media/hdd/movie/%s" % filename, "w")
                     metafile.write(text.replace(self.oldname,self.newname))
                     moviename = filename.split(".ts.meta")
                     oldmoviename = moviename[0].rstrip()
                     moviename = oldmoviename.split(" - ")
                     index = len(moviename)
                     oldfilename = moviename[index-1]
                     newmoviename = oldmoviename.replace(oldfilename,newtitle)
                     # inka 111 tries this                      
                     # newmoviename = newtitle
                     
                     if os.path.exists("/media/hdd/movie/%s.ts.meta" % newmoviename) is True:
                        self.skipRenameFile("Filename already exists")
                     else:
                        os.rename("/media/hdd/movie/%s.ts.meta" % oldmoviename, "/media/hdd/movie/%s.ts.meta" % newmoviename)
                        if os.path.exists("/media/hdd/movie/%s.eit" % oldmoviename) is True:
                           os.rename("/media/hdd/movie/%s.eit" % oldmoviename, "/media/hdd/movie/%s.eit" % newmoviename)
                        if os.path.exists("/media/hdd/movie/%s.ts.ap" % oldmoviename) is True:
                           os.rename("/media/hdd/movie/%s.ts.ap" % oldmoviename, "/media/hdd/movie/%s.ts.ap" % newmoviename)
                        if os.path.exists("/media/hdd/movie/%s.ts.cuts" % oldmoviename) is True:
                           os.rename("/media/hdd/movie/%s.ts.cuts" % oldmoviename, "/media/hdd/movie/%s.ts.cuts" % newmoviename)
                        if os.path.exists("/media/hdd/movie/%s.ts" % oldmoviename) is True:
                           os.rename("/media/hdd/movie/%s.ts" % oldmoviename, "/media/hdd/movie/%s.ts" % newmoviename)
                     
                  metafile.close()
            if metafound is True:
               self.session.open(MessageBox,_("rename moviefiles done, check by pressing Video button again !"), MessageBox.TYPE_INFO)
            else:
               self.session.open(MessageBox,_(".meta file not found, sorry"), MessageBox.TYPE_INFO)
            
    def skipRenameFile(self,reason):
        self.session.open(MessageBox,_("renaming moviefiles was cancelled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        

